Attribute VB_Name = "modDirectoryServer"
Option Explicit

Private ServerListBuffer As String
Private ReceivingServerList As Boolean
Private ReceivedServerList As Boolean

Private Sub Handler02(DecryptedPacket As String)
ReceivedServerList = 0
InitEncryption GetLong(Mid(DecryptedPacket, 3, 4))

'UDPSend Chr(0) + Chr(3) + NextSID + GetString(1) + Chr(0)
'SendSync 1
UDPSend Packet03
UDPSend Packet05

frmServerList.AddStatus "Sent login packet"
If frmServerList.HaveDirectoryServer(frmServerList.cmbDirectoryServer) = 0 Then
 frmServerList.cmbDirectoryServer.AddItem frmServerList.cmbDirectoryServer
 frmServerList.cmbDirectoryServer.ListIndex = frmServerList.cmbDirectoryServer.NewIndex
End If
frmServerList.chkDownload.ForeColor = vbGreen
frmServerList.AddStatus "Downloading server list"
ServerListBuffer = ""
End Sub

Private Sub Handler03(DecryptedPacket As String)
UDPSendNE Chr(0) + Chr(4) + Mid(DecryptedPacket, 3, 4)
If ReceivedServerList Then Exit Sub
ServerListBuffer = ServerListBuffer + Mid(DecryptedPacket, 13)

'''On Error Resume Next
'''Debug.Print Len(DecryptedPacket)
'''Open "c:\windows\desktop\a" For Binary Access Write As #5
''' Put #5, , ServerListBuffer
'''Close #5
'''Exit Sub
If Len(DecryptedPacket) = 486 Or Len(DecryptedPacket) = 492 Then
 ReceivingServerList = 1
'If Len(DecryptedPacket) < 492 Then
Else
 If ReceivingServerList Then
  ReceivingServerList = 0
  ReceivedServerList = 1
 End If
 LeaveServer
 frmServerList.AddStatus "Done receiving the server list"
 frmServerList.AddStatus "Leaving"
 frmServerList.GenerateServerList ServerListBuffer
 frmServerList.chkDownload.Caption = "Download"
 frmServerList.chkDownload.ForeColor = vbButtonText
 Screen.MousePointer = vbDefault
 AutoDownloadEvent = "" 'Flag for the timer to start auto download again
End If
End Sub

Private Sub Handler06(DecryptedPacket As String)
frmServerList.AddStatus "Sync packet accepted"
'UDPSendNE Chr(0) + Chr(4) + Mid(DecryptedPacket, 3, 4)
End Sub

Private Sub Handler07(DecryptedPacket As String)
frmServerList.AddStatus "Disconnected by server"
Screen.MousePointer = vbDefault
frmServerList.chkDownload.ForeColor = vbRed
'frmserverlist.SSL.Enabled = False
AutoDownloadEvent = "" 'Flag for the timer to start auto download again
End Sub

Private Sub Handler0E(DecryptedPacket As String)
If DecryptedPacket = "" Then Exit Sub
   
Dim b As Byte, S As String
    
S = Mid(DecryptedPacket, 3)
Do
 b = Asc(Left(S, 1))
 HandleDirectoryServer Mid(S, 2, b)
 S = Mid(S, b + 2)
Loop Until S = ""
End Sub

'Handler entry point
Public Sub HandleDirectoryServer(DecryptedPacket As String)
If DecryptedPacket = "" Then Exit Sub

Select Case Asc(Left(DecryptedPacket, 1))
 Case 0 '01type,SessionData
  Select Case Asc(Mid(DecryptedPacket, 2, 1))
   Case 1 '02type,SessionRequest
   Case 2: Handler02 DecryptedPacket 'KeyNotify
   Case 3: Handler03 DecryptedPacket 'ACKRequired
   Case 4 'ACKMessage
'    ReceivedACK sMsg: Exit Sub
   Case 5 'SyncClient
   Case 6: Handler06 DecryptedPacket 'SyncServer
   Case 7: Handler07 DecryptedPacket 'Disconnect
   Case 14: Handler0E DecryptedPacket 'PacketCluster
   Case Else
    frmServerList.AddStatus "Error: unknown O2 packet #" + CStr(Asc(Mid(DecryptedPacket, 2, 1)))
  End Select
 Case Else
  frmServerList.AddStatus "Error: unknown O1 packet #" + CStr(Asc(Left(DecryptedPacket, 1)))
End Select
End Sub
